#
# getdep.rb
#
#   Copyright (c) 1999 Minero Aoki <aamine@dp.u-netsurf.ne.jp>
#

require 'rbconfig'


module Getdep

  DL_EXT     = Config::CONFIG['DLEXT']
  DL_EXT_EXP = /\.#{DL_EXT}\z/o
  EXTENTIONS = [ '.rb', '.' + DL_EXT ]

  def findpath( fe )
    EXTENTIONS.each do |ext|
      $:.each do |dir|
        path = dir + '/' + fe + ext
        if File.exist? path then
          return path
        end
      end
    end

    return nil
  end


  def getdep( fn, done = {} )
    unless DL_EXT_EXP === fn then   # don't grep binary file
      new = []
      File.foreach( fn ) do |line|
        if /require\s+['"]([^'"]+)['"]/o === line then
          dep = $1
          unless done.key? dep then
            done[dep] = true
            new.push dep
          end
        end
      end

      new.each do |feature|
        unless path = findpath( feature ) then
          $stderr.puts "warn: can't find feature path for #{feature}"
        else
          done[feature] = path
          getdep path, done
        end
      end
    end

    done
  end

  module_function :findpath, :getdep

end
